<%@ Page Language="C#" %>

<%@ Import Namespace="Unibas.Aci.Modello" %>
<%@ Import Namespace="Unibas.Aci.Persistenza" %>
<%@ Import Namespace="Unibas.Aci.Form" %>

<%
    Utente utente = (Utente)Session["utente"];
    if (utente == null || !utente.Autenticato || !utente.Ruolo.Equals("amministratore")) {
        Context.Items["messaggio"] = "Autorizzazione fallita";
        Server.Transfer("default.aspx");
        return;
    }

    Response.AddHeader("Cache-Control", "no-cache");
    Response.AddHeader("Pragma", "no-cache");
    Response.AddHeader("Expires", DateTime.Now + "");

%>

<%
    FormProprietario formProprietario = new FormProprietario();
    formProprietario.CodiceFiscale = Request["codiceFiscale"];
    formProprietario.Nome = Request["nome"];
    formProprietario.CittaDiResidenza = Request["cittaDiResidenza"];
    formProprietario.AnnoPatente = Request["annoPatente"];
    System.Collections.IList errori = formProprietario.Convalida();
    if (errori.Count != 0) {
        Context.Items["errori"] = errori;
        Context.Items["formProprietario"] = formProprietario;
        Server.Transfer("schermoInserimentoProprietario.aspx");
        return;
    }   
    Proprietario proprietario = new Proprietario();
    proprietario.CodiceFiscale = Request["codiceFiscale"];
    proprietario.Nome = Request["nome"];
    proprietario.CittaDiResidenza = Request["cittaDiResidenza"];
    proprietario.AnnoPatente = Int32.Parse(Request["annoPatente"]);
    
    string messaggioErrore = null;
    try {
        DAOProprietario.DoInsert(proprietario);
    }catch (DAOException se){
        messaggioErrore = "" + se;
    }
%>

<!-- #include file="intestazione.aspx" -->

<%
    if (messaggioErrore == null) {
%>

<h2>Inserimento effettuato</h2>

<table class="proprietario">
  <tr>
    <td class="label">Nome Proprietario</td> <td class="dati"><% Response.Write(proprietario.Nome); %></td>
    <td class="label">Codice fiscale:</td><td class="dati"> <% Response.Write(proprietario.CodiceFiscale); %></td>
    <td class="label">Citta di Residenza</td> <td class="dati"><% Response.Write(proprietario.CittaDiResidenza); %></td>
    <td class="label">Anno Patente:</td> <td class="dati"><% Response.Write(proprietario.AnnoPatente); %></td>
  </tr>
</table>

<%
    } else {
%>

<h2>Errore: Inserimento impossibile: <%= messaggioErrore %></h2>

<%
    }
%>

<%

string uri = "";
if (utente.Ruolo.Equals("utente")) {
    uri = "schermoInizialeUtente.aspx";
} else if (utente.Ruolo.Equals("amministratore")) {
    uri = "schermoInizialeAmministratore.aspx";
}

%>

<p><strong><a href="<% Response.Write(uri); %>">Torna al menu</a></strong></p>

<!-- #include file="pieDiPagina.aspx" -->
