<%@ Page Language="C#" %>

<%@ Import Namespace="Unibas.Aci.Modello" %>
<%@ Import Namespace="Unibas.Aci.Persistenza" %>
<%@ Import Namespace="Unibas.Aci.Form" %>

<%
    Utente utente = (Utente)Session["utente"];
    if (utente == null || !utente.Autenticato || !utente.Ruolo.Equals("amministratore")) {
        Context.Items["messaggio"] = "Autorizzazione fallita";
        Server.Transfer("default.aspx");
        return;
    }

    Response.AddHeader("Cache-Control", "no-cache");
    Response.AddHeader("Pragma", "no-cache");
    Response.AddHeader("Expires", DateTime.Now + "");

%>

<!-- #include file="intestazione.aspx" -->

<%
    FormProprietario formProprietario = (FormProprietario)Context.Items["formProprietario"];
    System.Collections.IList errori = (System.Collections.IList)Context.Items["errori"];
    if (errori == null) {
        formProprietario = new FormProprietario();
    } else {
        Response.Write("<h2>I dati sottomessi non sono corretti</h2>");
        foreach (string errore in errori) {
            Response.Write("<li><strong>" + errore + "</strong></li>");
        }
        Response.Write("</ul>");
    }
%>

<h2>Inserisci i dati del proprietario</h2>

<form method="post" action="schermoEsitoInserimentoProprietario.aspx">
<table>
<tr>
<td><strong class="label">Codice Fiscale:</strong></td>
<td><input type="text" name="codiceFiscale"
                       value="<% Response.Write(formProprietario.CodiceFiscale); %>" />
</td>
</tr>
<tr>
<td><strong class="label">Nome e Cognome:</strong></td>
<td><input type="text" name="nome"
                       value="<% Response.Write(formProprietario.Nome); %>" />
</td>
</tr>
<tr>
<td><strong class="label">Citt&agrave; di Residenza:</strong></td>
<td><input type="text" name="cittaDiResidenza"
                       value="<% Response.Write(formProprietario.CittaDiResidenza); %>" />
</tr>
<tr>
<td><strong class="label">Anno di Conseguimento della Patente:</strong></td>
<td><input type="text" name="annoPatente"
                       value="<% Response.Write(formProprietario.AnnoPatente); %>" />
</tr>
</table>

<input type="submit" value="Inserisci" />
</form>

<%

string uri = "";
if (utente.Ruolo.Equals("utente")) {
    uri = "schermoInizialeUtente.aspx";
} else if (utente.Ruolo.Equals("amministratore")) {
    uri = "schermoInizialeAmministratore.aspx";
}

%>

<p><strong><a href="<% Response.Write(uri); %>">Torna al menu</a></strong></p>

<!-- #include file="pieDiPagina.aspx" -->
