namespace Unibas.Aci.Form {

using Unibas.Aci.Modello;
using Unibas.Aci.Persistenza;
using System;

public class FormProprietario {
    
    private string codiceFiscale = "";
    private string nome = "";
    private string cittaDiResidenza = "";
    private string annoPatente = "";
    
    public string CodiceFiscale {
        get { return this.codiceFiscale; }
        set { this.codiceFiscale = value; }    
    }
    
    public string Nome {
        get { return this.nome; }
        set { this.nome = value; }    
    }

    public string CittaDiResidenza {
        get { return this.cittaDiResidenza; }
        set { this.cittaDiResidenza = value; }    
    }

    public string AnnoPatente {
        get { return this.annoPatente; }
        set { this.annoPatente = value; }    
    }

    public System.Collections.IList Convalida(){
        System.Collections.IList errori= new System.Collections.ArrayList();
        if (this.codiceFiscale.Equals("")) {
            errori.Add("Errore nel valore del codice fiscale: il valore non puo' essere nullo");
        } else if (this.codiceFiscale.Length != 6) {
            errori.Add("Errore nel valore del codice fiscale: il valore deve contenere esattamente 6 caratteri");
        }
        if (errori.Count == 0) {
            try {
                Proprietario proprietario = DAOProprietario.DoSelectCodiceFiscale(this.codiceFiscale);
                if (proprietario != null) {
                    errori.Add("Errore: codice fiscale gia' esistente nella base di dati");
                }
            } catch (DAOException daoe) {
                System.Console.WriteLine(daoe);
            }
        }
        if (this.nome.Equals("")) {
            errori.Add("Errore nel valore del nome: il valore deve essere non nullo");
        } else if (this.nome.IndexOf(" ") == -1) {
            errori.Add("Errore nel valore del nome: il valore deve contenere nome e cognome");
        }
        try {
            int anno = Int32.Parse(this.annoPatente);
            if (anno < 1920) {
                errori.Add("Errore nel valore dell'anno: il valore deve essere compreso tra 1920 e 2002");
            }
        } catch(FormatException) {
            errori.Add("Errore nel valore dell'anno: il valore deve essere un numero intero");
        }
        return errori;
    }
}

}