namespace Unibas.Aci.Modello {

using System.Collections;
    
public class Proprietario {

    private string codiceFiscale;
    private string nome;
    private string cittaDiResidenza;
    private int annoPatente;
    private IList automobili = new ArrayList();

    public string CodiceFiscale {
        get { return this.codiceFiscale; }
        set { this.codiceFiscale = value; }
    }    
    
    public string Nome {
        get { return this.nome; }
        set { this.nome = value; }
    }
    
    public string CittaDiResidenza {
        get { return this.cittaDiResidenza; }
        set { this.cittaDiResidenza = value; }
    }
    
    public int AnnoPatente {
        get { return this.annoPatente; }
        set { this.annoPatente = value; }
    }
    
    public Automobile GetAutomobile(int i) {
        if (i < 0 || i >= automobili.Count) {
            return null;
        }
        return (Automobile)this.automobili[i];
    }

    public void SvuotaAutomobili() {
        this.automobili.Clear();
    }

    public void AggiungiAutomobile(Automobile automobile) {
        int posizione = CercaAutomobile(automobile.Targa);
        if (posizione == -1) {
            this.automobili.Add(automobile);
            automobile.Proprietario = this;
        }
    }

    public void EliminaAutomobile(int i) {
        if (i < 0 || i >= automobili.Count) {
            throw new System.ArgumentException("Posizione scorretta");
        }
        this.automobili.Remove(i);
    }

    public int NumeroAutomobili {
        get { return this.automobili.Count; }
    }

    public int CercaAutomobile(string targa) {
        foreach (Automobile automobile in this.automobili) {
            if (automobile.Targa.Equals(targa)) {
                return automobili.IndexOf(automobile);
            }
        }
        return -1;
    }
        
        
}
    
}

