namespace Unibas.Aci.Persistenza {

using System.Data;
using System.Collections;
using Unibas.Aci.Modello;

public class DAOProprietario {

    public static Proprietario DoSelectCodiceFiscale(string codiceFiscale) {
        DataSource dataSource = DataSource.GetInstance();
        IDbConnection connection = null;
        IDbCommand command = null;
        IDataReader dataReader = null;
        Proprietario proprietario = null;
        try {
            connection = dataSource.GetConnection();
            command = connection.CreateCommand();
            string query = "select * from proprietari "+
                    "where codicefiscale = '" + codiceFiscale + "'";
            command.CommandText = query;
            dataReader = command.ExecuteReader();
            if (dataReader.Read()) {
                proprietario = new Proprietario();
                proprietario.CodiceFiscale = (string)dataReader["codicefiscale"];
                proprietario.Nome = (string)dataReader["nome"];
                proprietario.CittaDiResidenza = (string)dataReader["cittadiresidenza"];
                proprietario.AnnoPatente = (int)dataReader["annoPatente"];
            }
        } catch (System.Exception sqle) {
            throw new DAOException("DoInsert: " + sqle);
        } finally {
            dataSource.Close(dataReader);
            dataSource.Close(connection);
        }
        return proprietario;
    }

    public static IList DoSelectNome(string nome) {
        DataSource dataSource = DataSource.GetInstance();
        IDbConnection connection = null;
        IDbCommand command = null;
        IDataReader dataReader = null;
        IList listaProprietari = new ArrayList();
        try {
            connection = dataSource.GetConnection();
            command = connection.CreateCommand();
            string query = "select * from proprietari "+
                    "where nome = '" + nome + "'";
            command.CommandText = query;
            dataReader = command.ExecuteReader();
            while (dataReader.Read()) {
                Proprietario proprietario = new Proprietario();
                proprietario.CodiceFiscale = (string)dataReader["codicefiscale"];
                proprietario.Nome = (string)dataReader["nome"];
                proprietario.CittaDiResidenza = (string)dataReader["cittadiresidenza"];
                proprietario.AnnoPatente = (int)dataReader["annoPatente"];
                listaProprietari.Add(proprietario);
            }
        } catch (System.Exception sqle) {
            throw new DAOException("DoInsert: " + sqle);
        } finally {
            dataSource.Close(dataReader);
            dataSource.Close(connection);
        }
        return listaProprietari;
    }

    public static void DoInsert(Proprietario proprietario) {
        DataSource dataSource = DataSource.GetInstance();
        IDbConnection connection = null;
        IDbCommand command = null;
        try {
            connection = dataSource.GetConnection();
            command = connection.CreateCommand();
            string query = "insert into proprietari values (" +
                    "'" + proprietario.CodiceFiscale + "'," +
                    "'" + proprietario.Nome + "'," +
                    "'" + proprietario.CittaDiResidenza + "'," +
                    "" + proprietario.AnnoPatente + ")";
            command.CommandText = query;
            command.ExecuteNonQuery();
        } catch (System.Exception sqle) {
            throw new DAOException("DoInsert: " + sqle);
        } finally {
            dataSource.Close(connection);
        }
    }
    
    public static void DoDelete(Proprietario proprietario) {
        DataSource dataSource = DataSource.GetInstance();
        IDbConnection connection = null;
        IDbCommand command = null;
        try {
            connection = dataSource.GetConnection();
            command = connection.CreateCommand();
            string query = "delete from proprietari " +
                    "where codicefiscale = '" + proprietario.CodiceFiscale + "'";
            command.CommandText = query;
            command.ExecuteNonQuery();
        } catch (System.Exception sqle) {
            throw new DAOException("DoDelete: " + sqle);
        } finally {
            dataSource.Close(connection);
        }
    }
    
    public static void DoUpdate(Proprietario proprietario) {
        DataSource dataSource = DataSource.GetInstance();
        IDbConnection connection = null;
        IDbCommand command = null;
        try {
            connection = dataSource.GetConnection();
            command = connection.CreateCommand();
            string query =
                    "update proprietari set " +
                    "nome = '" + proprietario.Nome + "'," +
                    "cittadiresidenza = '" + proprietario.CittaDiResidenza + "'," +
                    "annopatente = " + proprietario.AnnoPatente + " " +
                    "where codicefiscale = '" + proprietario.CodiceFiscale + "'";
            command.CommandText = query;
            command.ExecuteNonQuery();
        } catch (System.Exception sqle) {
            throw new DAOException("DoUpdate: " + sqle);
        } finally {
            dataSource.Close(connection);
        }
    }

    public static void CaricaAutomobili(Proprietario proprietario) {
        DataSource dataSource = DataSource.GetInstance();
        IDbConnection connection = null;
        IDbCommand command = null;
        IDataReader dataReader = null;
        try {
            connection = dataSource.GetConnection();
            command = connection.CreateCommand();
            string query = "select automobili.* " +
                    "from automobili " +
                    "where automobili.proprietario = '" + proprietario.CodiceFiscale + "'";
            command.CommandText = query;
            dataReader = command.ExecuteReader();
            proprietario.SvuotaAutomobili();
            while (dataReader.Read()) {
                Automobile automobile = new Automobile();
                automobile.Targa = (string)dataReader["targa"];
                automobile.Modello = (string)dataReader["modello"];
                automobile.Cilindrata = (int)dataReader["cilindrata"];
                automobile.Proprietario = proprietario;
                proprietario.AggiungiAutomobile(automobile);
            }
        } catch (System.Exception sqle) {
            throw new DAOException("DoInsert: " + sqle);
        } finally {
            dataSource.Close(connection);
        }
    }

}

}
